-----------------------------------
----------Scene OBJECT LISTER------
-----------------------------------
fn listObjectsNamesScene question nothing =
(
	listo = #()
	if geometry.count > 0 then
	(	print "---Object list---"

		listo[1] = geometry[1].name

		for i=2 to geometry.count do
		(	tmpResult = true
				--// test to see if this object is unique to the list
			for j=1 to listo.count do
				if i != j do
					if geometry[i].name == listo[j] do
						tmpResult = false
			if tmpResult == true do
			(	tmpCt = listo.count + 1
				listo[tmpCt] = geometry[i].name
			)
		)
		if question == 1 do
		(	f=fopen nothing "wb"
			WriteLong f listo.count
			for i=1 to listo.count do
				writestring f (listo[i] as string)
			fclose f
		)
		for i=1 to listo.count do
			format ((listo[i] as string)+"\n")
	)
	else print "**ERROR: 0 geometry objects in this scene"
	return listo
)
-- tmp = "c:\\ObjectNames.db"
-- listObjectsNamesScene 1 tmp
---------------------------------------------
-- FILE LIST RENAME >TXT
---------------------------------------------
fn renameLibraryFromList filen saveit=
(	print ("Library list file: "+(filen as string))
	if saveit then
	(	f = createFile filen
		format "%\n" geometry.count to:f
		for i=1 to geometry.count do
			format "%\n%\n\n" geometry[i].name (lowerCase geometry[i].name) to:f
		close f
	)
	else
	(	f = openFile filen
		tmp1 = "none"; tmp2 = "none"
		cnt = readvalue f
		for i=1 to cnt do
		(	tmp1 = readline f
			tmp2 = readline f
			print (tmp2 as string)
			geometry[i].name = tmp2
			skipToNextLine f
		)
		close f
	)
)
---------------------------------------------
--------------- Read a bf1942 sun position ----
fn ReadSkyBf thisFile scaleLight =
(
	f = openFile thisFile mode:"rt"
	if (f != undefined) do
	(	setRotAngle = 0
		sunLightDirectionVec = [0,0,0]
		( -- read in data
			skipToString f "otAngle "
			setRotAngle = (readValue f)
			seek f 0
			skipToString f "sunLightDirectionVec "

			sunLightDirectionVec.x = (readValue f)
			readchar f
			sunLightDirectionVec.z = (readValue f)
			readchar f
			sunLightDirectionVec.y = (readValue f)
			close f
		)
		print (sunLightDirectionVec as string)

		worldsizeA = 4096
		f2 = openFile ((getFilenamePath thisFile)+"Terrain.con") mode:"rt"
		if f2 != undefined do
		(	skipToString f2 "GeometryTemplate.worldSize "
			worldsizeA = (readValue f2)
			close f2
			print (worldsizeA as string)
		)
		worldsizeB = worldsizeA * 0.5
		b = DirectionalLight name:"Bf_Light" transform:(MatrixFromNormal sunLightDirectionVec)
		b.falloff = worldsizeA
		b.hotspot = worldsizeA - 1

		b.pos.x = scaleLight * worldsizeA * sunLightDirectionVec.x + worldsizeB
		b.pos.y = scaleLight * worldsizeA * sunLightDirectionVec.y + worldsizeB
		b.pos.z = scaleLight * worldsizeA * sunLightDirectionVec.z

		return b
	)
)

---------------------------------------------
-- SETUPLIGHTMAPS SELECTED
---------------------------------------------
mapped fn SetupLightmapBF thisObject =
(
	be = LightingMap()
	tOb = thisObject.INodeBakeProperties 
	thisObject.bakeEnabled = true
	
	tOb.bakeChannel = 3 -- should be moved to 3
	tOb.addBakeElement be

tx = "_"
tx = tx + ((thisObject.pos.x as integer) as string) + "-"
tx = tx + ((thisObject.pos.z as integer) as string) + "-"
tx = tx + ((thisObject.pos.y as integer) as string)
	print tx
	be.elementName  = tx
	be.autoSzOn = true
	
)